package jp.maxwell.applet.simson;
import java.applet.*;
import java.awt.*;

/*
 * 最も基本的な、動くアプレットのテンプレートです。 
 * <applet code="AppletTemplate.class" width="200" height="200"></applet>
 * 
 */

/**
 * @author Osamu Koizumi
 *
 */
abstract class PhysicsApplet extends Applet implements Runnable{
    /** スレッド */
    Thread th;
    /** 経過時間を保持する変数 */
    double t = 0;
    /** 時間の刻み (ミリ秒単位) */
    int dt = 100;

    /*
     * アプレットの実行が始まると呼ばれます。
     * @see java.applet.Applet#init()
     */
    public void start(){
        // おまじない
        if( th == null){
            th = new Thread( this);
            th.start();
        }
    }
    
    /*
     * このメソッドには反復処理を記述します。
     * @see java.lang.Runnable#run()
     */
    public void run(){
        while( th != null){
            /*
             * ここに計算などの処理を記述します。
             */
            routine();
            
            // 計算結果を画面に反映させるために再描画する
            repaint();
    
            // 時間を進める (dt を秒単位に直すために1000で割る)
            t = t + dt/1000.0;
    
            // 刻み時間だけ待つ
            try{
                Thread.sleep( dt);
            }
            catch( InterruptedException ex){
            }
        }
    }
    
    
    /*
     * 時間 dt ごとに呼び出されるメソッド。
     * 継承したクラスでオーバーライドする。
     */
    abstract public void routine();

    /*
     * アプレット停止時に呼ばれます。
     * @see java.applet.Applet#stop()
     */
    public void stop(){
        th = null;
    }
}
